diff --git a/lib/hive/daemon/auto_retry_history.rb b/lib/hive/daemon/auto_retry_history.rb
new file mode 100644
index 00000000..ec855988
--- /dev/null
+++ b/lib/hive/daemon/auto_retry_history.rb
@@ -0,0 +1,183 @@
+require "json"
+require "time"
+require "hive/events"
+
+module Hive
+  module Daemon
+    # Durable, append-only retry budget reconstructed from task events.
+    # Only a successful manual marker clear starts a new reason episode.
+    class AutoRetryHistory
+      MAX_ATTEMPTS = 2
+      SECOND_ATTEMPT_BACKOFF_SEC = 1800
+
+      Decision = Struct.new(
+        :eligible, :attempt, :action, :rationale, :previous_fingerprint,
+        :previous_reserved_at,
+        keyword_init: true
+      )
+
+      # Cheap pre-probe gate. It prevents external health commands from
+      # running while the second-attempt backoff is active or after the
+      # durable episode is exhausted. Fingerprint comparison remains in
+      # #assess after a fresh/cached aggregate is available.
+      def budget(task_folder:, reason:, now: Time.now)
+        reservations = episode_reservations(task_folder, reason)
+        return invalid_decision(reservations) if reservations.is_a?(String)
+
+        case reservations.length
+        when 0
+          Decision.new(eligible: true, attempt: 1, action: "retry_eligible",
+                       rationale: "first automatic attempt is available")
+        when 1
+          reserved_at = Time.iso8601(reservations.first.fetch("timestamp"))
+          if (now - reserved_at) < SECOND_ATTEMPT_BACKOFF_SEC
+            Decision.new(
+              eligible: false, action: "retry_backoff",
+              rationale: "second attempt requires a 30-minute backoff",
+              previous_fingerprint: reservations.first.fetch("health_fingerprint"),
+              previous_reserved_at: reserved_at
+            )
+          else
+            Decision.new(
+              eligible: true, attempt: 2, action: "retry_probe_due",
+              rationale: "second-attempt backoff elapsed",
+              previous_fingerprint: reservations.first.fetch("health_fingerprint"),
+              previous_reserved_at: reserved_at
+            )
+          end
+        else
+          Decision.new(eligible: false, attempt: nil, action: "retry_exhausted",
+                       rationale: "two automatic attempts are already reserved")
+        end
+      rescue KeyError, ArgumentError
+        invalid_decision("malformed first reservation")
+      end
+
+      def assess(task_folder:, reason:, fingerprint:, now: Time.now)
+        reservations = episode_reservations(task_folder, reason)
+        return invalid_decision(reservations) if reservations.is_a?(String)
+
+        case reservations.length
+        when 0
+          Decision.new(eligible: true, attempt: 1, action: "retry_eligible",
+                       rationale: "first automatic attempt is available")
+        when 1
+          assess_second(reservations.first, fingerprint, now)
+        else
+          Decision.new(eligible: false, attempt: nil, action: "retry_exhausted",
+                       rationale: "two automatic attempts are already reserved")
+        end
+      end
+
+      def reserved_attempt(task_folder:, reason:, marker_id:)
+        reservations = episode_reservations(task_folder, reason)
+        return nil if reservations.is_a?(String)
+
+        reservation = reservations.reverse.find do |details|
+          details["marker_id"].to_s == marker_id.to_s
+        end
+        reservation && reservation["attempt"]
+      end
+
+      def reserve!(task_folder:, task_id: nil, slug:, stage:, marker_id:, reason:, fingerprint:,
+                   attempt:, probes:, now: Time.now)
+        record = Hive::Events.emit_required(
+          task_folder: task_folder,
+          slug: slug,
+          stage: stage,
+          event_type: :auto_retry_reserved,
+          message: "reserved automatic retry attempt #{attempt} for #{reason}",
+          details: {
+            "task_id" => task_id,
+            "task_slug" => slug,
+            "stage" => stage,
+            "marker_id" => marker_id,
+            "marker_reason" => reason,
+            "actor" => "daemon_auto_retry",
+            "probes" => probes,
+            "health_fingerprint" => fingerprint,
+            "attempt" => attempt,
+            "action" => "retry_reserved",
+            "rationale" => "health and safety gates passed",
+            "timestamp" => now.utc.iso8601(6)
+          }
+        )
+        !record.nil?
+      rescue ArgumentError, JSON::GeneratorError, SystemCallError, IOError
+        false
+      end
+
+      private
+
+      def assess_second(first, fingerprint, now)
+        previous_fingerprint = first.fetch("health_fingerprint")
+        reserved_at = Time.iso8601(first.fetch("timestamp"))
+        if previous_fingerprint == fingerprint
+          return Decision.new(
+            eligible: false, action: "health_unchanged",
+            rationale: "second attempt requires a changed health fingerprint",
+            previous_fingerprint: previous_fingerprint,
+            previous_reserved_at: reserved_at
+          )
+        end
+        if (now - reserved_at) < SECOND_ATTEMPT_BACKOFF_SEC
+          return Decision.new(
+            eligible: false, action: "retry_backoff",
+            rationale: "second attempt requires a 30-minute backoff",
+            previous_fingerprint: previous_fingerprint,
+            previous_reserved_at: reserved_at
+          )
+        end
+
+        Decision.new(
+          eligible: true, attempt: 2, action: "retry_eligible",
+          rationale: "health changed and the 30-minute backoff elapsed",
+          previous_fingerprint: previous_fingerprint,
+          previous_reserved_at: reserved_at
+        )
+      rescue KeyError, ArgumentError
+        invalid_decision("malformed first reservation")
+      end
+
+      def episode_reservations(task_folder, reason)
+        path = File.join(task_folder, "events.jsonl")
+        return [] unless File.exist?(path)
+
+        events = File.readlines(path, chomp: true).reject(&:empty?).map { |line| JSON.parse(line) }
+        reset_index = events.rindex do |event|
+          manual_reset_for_reason?(event, reason)
+        end
+        episode = reset_index ? events[(reset_index + 1)..] : events
+        reservations = episode.select do |event|
+          event["event_type"] == "auto_retry_reserved" &&
+            event.dig("details", "marker_reason").to_s == reason.to_s
+        end
+        return "malformed retry reservation" unless reservations.all? { |event| valid_reservation?(event) }
+
+        reservations.map { |event| event.fetch("details") }
+      rescue JSON::ParserError, SystemCallError, IOError
+        "malformed or unreadable event history"
+      end
+
+      def manual_reset_for_reason?(event, reason)
+        event["event_type"] == "marker_cleared" &&
+          event.dig("details", "actor") == "manual" &&
+          event.dig("details", "marker_reason").to_s == reason.to_s
+      end
+
+      def valid_reservation?(event)
+        details = event["details"]
+        details.is_a?(Hash) &&
+          details["attempt"].is_a?(Integer) &&
+          details["attempt"].between?(1, MAX_ATTEMPTS) &&
+          !details["health_fingerprint"].to_s.empty? &&
+          !details["timestamp"].to_s.empty?
+      end
+
+      def invalid_decision(reason)
+        Decision.new(eligible: false, attempt: nil, action: "history_invalid",
+                     rationale: reason.to_s)
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/auto_retry_policy.rb b/lib/hive/daemon/auto_retry_policy.rb
new file mode 100644
index 00000000..360d7c42
--- /dev/null
+++ b/lib/hive/daemon/auto_retry_policy.rb
@@ -0,0 +1,277 @@
+require "hive/brainstorm_parser"
+require "hive/config"
+require "hive/daemon/bounded_command"
+require "hive/diagnostic_helpers"
+require "hive/markers"
+require "hive/task"
+require "hive/worktree"
+
+module Hive
+  module Daemon
+    # Eligibility and work-safety half of dependency recovery. It never
+    # probes dependencies, appends events, clears markers, or queues work.
+    class AutoRetryPolicy
+      REASONS = %w[implementer_failed claude_launch_failed].freeze
+      CLAUDE_LAUNCH_STAGES = %w[
+        2-brainstorm 3-plan 4-execute 5-open-pr 7-artifacts 8-finalize
+      ].freeze
+      WORKTREE_STAGES = %w[
+        4-execute 5-open-pr 6-review 7-artifacts 8-finalize
+      ].freeze
+      CODEX_AUTH_STATUS = /\b401\b/.freeze
+      CODEX_AUTH_DIAGNOSTIC = /missing bearer or basic authentication(?:\s+in\s+header)?/i.freeze
+      CODEX_EXIT_MESSAGE = /\Aexit_code=\d+\z/.freeze
+      CODEX_AGENT = "codex".freeze
+      CODEX_LOG_BASENAME = /\Aexecute-impl-[A-Za-z0-9._-]+\.log\z/.freeze
+      CLAUDE_MARKER_WRITER = "stages_base_claude_launcher".freeze
+      WORKTREE_COMMAND_TIMEOUT_SEC = 10
+      WORKTREE_CAPTURE_BYTES = 4096
+
+      Decision = Struct.new(
+        :eligible, :action, :rationale, :reason, :marker_id, :task,
+        keyword_init: true
+      )
+
+      def initialize(task_builder: ->(folder) { Hive::Task.new(folder) },
+                     command_runner: nil,
+                     config_loader: ->(root) { Hive::Config.load(root) })
+        @task_builder = task_builder
+        @config_loader = config_loader
+        @command_runner = command_runner || lambda do |argv:, chdir:, timeout_sec:|
+          Hive::Daemon::BoundedCommand.capture(
+            env: {}, argv: argv, chdir: chdir,
+            timeout_sec: timeout_sec, max_bytes: WORKTREE_CAPTURE_BYTES
+          )
+        end
+      end
+
+      def evaluate(row)
+        marker_attrs = row.marker_attrs.to_h
+        reason = marker_attrs["reason"].to_s
+        marker_id = marker_attrs["marker_id"].to_s
+        return deny("not_current_terminal_error", "row is not a current terminal ERROR") unless terminal_error?(row)
+        return deny("marker_id_missing", "current ERROR marker has no marker_id") if marker_id.empty?
+        return deny("reason_not_allowlisted", "marker reason is not recoverable") unless REASONS.include?(reason)
+
+        task = @task_builder.call(row.folder)
+        diagnostic = classify_reason(reason, row, task)
+        return diagnostic unless diagnostic.eligible
+
+        safety = safe_to_retry(row, task)
+        return safety unless safety.eligible
+
+        Decision.new(
+          eligible: true,
+          action: "eligible",
+          rationale: "recognized dependency failure and stage output is safe",
+          reason: reason,
+          marker_id: marker_id,
+          task: task
+        )
+      rescue StandardError => e
+        deny("policy_error", "#{e.class}: #{e.message}")
+      end
+
+      private
+
+      def terminal_error?(row)
+        row.marker.to_s == "error" && row.action.to_s == "error" &&
+          !row.folder.to_s.empty? && !row.state_file.to_s.empty?
+      end
+
+      def classify_reason(reason, row, task)
+        case reason
+        when "implementer_failed" then codex_auth_failure(row, task)
+        when "claude_launch_failed" then claude_launch_failure(row)
+        else deny("reason_not_allowlisted", "marker reason is not recoverable")
+        end
+      end
+
+      def codex_auth_failure(row, task)
+        return deny("codex_wrong_stage", "Codex auth recovery is execute-only") unless row.stage.to_s == "4-execute" # coding-scoped: Codex implementer auth recovery
+
+        attrs = row.marker_attrs.to_h
+        unless configured_execute_agent(task) == CODEX_AGENT &&
+               attrs["agent"].to_s == CODEX_AGENT
+          return deny(
+            "codex_agent_mismatch",
+            "current execute failure is not attributed to the configured Codex agent"
+          )
+        end
+        unless attrs["status"].to_s == "error" &&
+               CODEX_EXIT_MESSAGE.match?(attrs["message"].to_s)
+          return deny(
+            "codex_execute_marker_invalid",
+            "marker is not the production execute failure shape"
+          )
+        end
+
+        log_basename = attrs["log_file"].to_s
+        unless CODEX_LOG_BASENAME.match?(log_basename) &&
+               File.basename(log_basename) == log_basename
+          return deny(
+            "codex_log_episode_ambiguous",
+            "current execute marker does not identify its exact implementer log"
+          )
+        end
+        log_path = File.join(task.log_dir, log_basename)
+        return deny("codex_log_missing", "current execute implementer log is missing") unless File.file?(log_path)
+
+        log_text = Hive::DiagnosticHelpers.tail_file(log_path)
+        unless codex_auth_signature?(log_text)
+          return deny("codex_auth_signature_missing", "current execute log does not contain both auth signatures")
+        end
+        if File.mtime(log_path) > File.mtime(row.state_file)
+          return deny("codex_log_episode_ambiguous", "execute log is newer than the current marker")
+        end
+
+        allow("codex_auth_recognized", "current execute marker and exact log prove Codex authentication failure")
+      rescue SystemCallError, IOError
+        deny("codex_log_unreadable", "current execute diagnostic cannot be read")
+      end
+
+      def codex_auth_signature?(text)
+        text.match?(CODEX_AUTH_STATUS) && text.match?(CODEX_AUTH_DIAGNOSTIC)
+      end
+
+      def configured_execute_agent(task)
+        config = @config_loader.call(task.project_root)
+        (config.dig("execute", "agent") || "claude").to_s
+      end
+
+      def claude_launch_failure(row)
+        attrs = row.marker_attrs.to_h
+        unless CLAUDE_LAUNCH_STAGES.include?(row.stage.to_s)
+          return deny("claude_stage_unsupported", "stage does not produce the v1 Claude launcher marker")
+        end
+        unless attrs["writer"].to_s == CLAUDE_MARKER_WRITER &&
+               attrs["exception_class"].to_s == "Hive::AgentError" &&
+               !attrs["message"].to_s.empty?
+          return deny("claude_marker_unattributed", "marker lacks the Claude launcher boundary attribution")
+        end
+
+        allow("claude_launch_recognized", "marker was written by the Claude launcher failure boundary")
+      end
+
+      def safe_to_retry(row, task)
+        current = Hive::Markers.current(row.state_file)
+        unless current.name == :error && current.attrs["marker_id"].to_s == row.marker_attrs.to_h["marker_id"].to_s
+          return deny("marker_changed", "on-disk marker no longer matches the status row")
+        end
+        if terminal_success_present?(row.state_file)
+          return deny("terminal_success_present", "current stage already has terminal success output")
+        end
+
+        case row.stage.to_s
+        when "2-brainstorm" then brainstorm_safe(row.state_file) # coding-scoped: coding brainstorm Q&A safety
+        when "3-plan" then plan_safe(row.state_file) # coding-scoped: coding plan content safety
+        when *WORKTREE_STAGES then worktree_safe(task)
+        else deny("stage_safety_unknown", "stage has no fail-closed safety predicate")
+        end
+      rescue SystemCallError, IOError
+        deny("stage_state_unreadable", "stage output cannot be read safely")
+      end
+
+      def brainstorm_safe(path)
+        questions = Hive::BrainstormParser.parse(path)
+        if Hive::BrainstormParser.answered_questions(questions).any?
+          return deny("brainstorm_answered", "brainstorm contains answered user Q&A")
+        end
+
+        allow("brainstorm_untouched", "brainstorm has no answered user Q&A")
+      end
+
+      def plan_safe(path)
+        text = File.read(path, encoding: "UTF-8")
+        body = strip_plan_scaffolding(text)
+        return deny("plan_substantive", "plan contains substantive content") unless body.empty?
+
+        allow("plan_untouched", "plan contains only runner scaffolding")
+      end
+
+      def strip_plan_scaffolding(text)
+        scrubbed = text.scrub
+        scrubbed.gsub(Hive::Markers::MARKER_RE, "")
+                .lines
+                .reject { |line| line.strip.empty? || line.match?(/\A\s*[#]{1,6}\s*(?:Plan|Feedback)?\s*\z/i) }
+                .join
+                .strip
+      end
+
+      def worktree_safe(task)
+        pointer_path = task.worktree_yml_path
+        return deny("worktree_pointer_missing", "worktree.yml is missing") unless File.file?(pointer_path)
+
+        pointer = Hive::Worktree.read_pointer(task.folder)
+        return deny("worktree_pointer_invalid", "worktree.yml cannot be parsed") unless pointer.is_a?(Hash)
+
+        raw_path = pointer["path"].to_s
+        return deny("worktree_pointer_invalid", "worktree.yml has no path") if raw_path.empty?
+
+        expected_root = Hive::Worktree.canonical_root(task.project_root)
+        path = Hive::Worktree.validate_pointer_path(raw_path, expected_root)
+        return deny("worktree_missing", "worktree directory is missing") unless File.directory?(path)
+
+        listed = run_git(
+          task.project_root,
+          [ "git", "-C", task.project_root, "worktree", "list", "--porcelain" ]
+        )
+        return listed if listed.is_a?(Decision)
+
+        registered = listed.stdout.to_s.lines.filter_map do |line|
+          next unless line.start_with?("worktree ")
+
+          Hive::Worktree.realpath_or_expand(line.delete_prefix("worktree ").strip)
+        end
+        unless registered.include?(Hive::Worktree.realpath_or_expand(path))
+          return deny("worktree_unregistered", "worktree is not registered with the project repository")
+        end
+
+        status = run_git(
+          path,
+          [ "git", "-C", path, "status", "--porcelain=v1", "--untracked-files=all" ]
+        )
+        return status if status.is_a?(Decision)
+        unless status.stdout.to_s.empty?
+          return deny("worktree_dirty", "worktree contains uncommitted or untracked files")
+        end
+
+        allow("worktree_clean", "worktree is completely clean")
+      rescue Hive::WorktreeError
+        deny("worktree_pointer_invalid", "worktree pointer is outside the configured root")
+      rescue SystemCallError, IOError
+        deny("worktree_status_failed", "worktree safety check could not run")
+      end
+
+      def run_git(chdir, argv)
+        result = @command_runner.call(
+          argv: argv, chdir: chdir, timeout_sec: WORKTREE_COMMAND_TIMEOUT_SEC
+        )
+        if result.timed_out
+          return deny("worktree_status_timeout", "git worktree safety check timed out")
+        end
+        unless result.status&.success?
+          message = result.stderr.to_s.lines.first.to_s.strip
+          return deny("worktree_status_failed", "git worktree safety check failed: #{message}")
+        end
+
+        result
+      end
+
+      def terminal_success_present?(path)
+        File.read(path, encoding: "UTF-8").to_enum(:scan, Hive::Markers::MARKER_RE).any? do
+          marker_name = Regexp.last_match[:name].downcase.to_sym
+          Hive::Markers::TERMINAL_MARKER_NAMES.include?(marker_name)
+        end
+      end
+
+      def allow(action, rationale)
+        Decision.new(eligible: true, action: action, rationale: rationale)
+      end
+
+      def deny(action, rationale)
+        Decision.new(eligible: false, action: action, rationale: rationale)
+      end
+    end
+  end
+end
